//
//  NoteDetailView.swift
//  SlipboxProject
//
//  Created by Karin Prater on 19.11.22.
//

import SwiftUI

struct NoteDetailView: View {
    
    @ObservedObject var note: Note
    
    var body: some View {
        
       // let textBinding = Binding(
       //     get: { note.title ?? "" },
       //     set: { note.title = $0 }
       // )
        
      return VStack(spacing: 20) {
            Text("Note Detail View")
                .font(.title)
            HStack {
                Text("Title:")
                
                Text(note.title)
            }
            
            Button("clear title") {
                note.title = ""
            }
            
          TextField("title", text: $note.title)
              .textFieldStyle(.roundedBorder)
              
            
            Button("Delete Note") {
                let context = note.managedObjectContext
                context?.delete(note)
            }
            .foregroundColor(.pink)
        }
      .padding()
        
      .onDisappear {
          PersistenceController.shared.save()
      }
        
    }
}

struct NoteDetailView_Previews: PreviewProvider {
    static var previews: some View {
        let context = PersistenceController.preview.container.viewContext
        let note = Note(title: "New note", context: context)
        
       return NoteDetailView(note: note)
            .environment(\.managedObjectContext, context)
    }
}
